
Include "data.geo";

Geometry.ExtrudeReturnLateralEntities = 0;

lcdom = Ri/10;

Point(1) = {0,0,0}; Point(2) = {ln/2,0,0};
Point(3) = {ln/2,pE/2,0}; Point(4) = {0,pE/2,0};
Line(1) = {1,2}; Line(2) = {2,3}; 
Line(3) = {3,4}; Line(4) = {4,1};
Line Loop(1) = {1,2,3,4}; Plane Surface(1) = {1};

Point(5) = {ln/2+ei,0,0}; Point(6) = {ln/2+ei,pE/2,0};
Point(7) = {ln/2,pE/2+ei,0}; Point(8) = {0,pE/2+ei,0};
Line(5) = {2,5}; Line(6) = {5,6}; Line(7) = {3,6};
Line Loop(2) = {5,6,-7,-2}; Plane Surface(2) = {2};

Circle(8) = {6,3,7}; Line(9) = {3,7}; 
Line Loop(3) = {7,8,-9}; Plane Surface(3) = {3};

Line(10) = {7,8}; Line(11) = {4,8};
Line Loop(4) = {9,10,-11,-3}; Plane Surface(4) = {4};

Point(9) = {ln/2+lb-ei,0,0}; Point(10) = {ln/2+lb-ei,pE/2,0};
Point(11) = {ln/2,pE/2+lb-ei,0}; Point(12) = {0,pE/2+lb-ei,0};

Line(12) = {5,9}; Line(13) = {9,10}; Line(14) = {6,10};
Line Loop(5) = {12,13,-14,-6}; Plane Surface(5) = {5};

Circle(15) = {10,3,11}; Line(16) = {7,11};
Line Loop(6) = {14,15,-16,-8}; Plane Surface(6) = {6};

Line(17) = {11,12}; Line(18) = {8,12};
Line Loop(7) = {-10,16,17,-18}; Plane Surface(7) = {7};

Point(13) = {ln/2+lb,0,0}; Point(14) = {ln/2+lb,pE/2,0};
Line(19) = {9,13}; Line(20) = {13,14}; Line(21) = {14,10};
Line Loop(8) = {19,20,21,-13}; Plane Surface(8) = {8};

Point(15) = {lE/2,0,0}; Point(16) = {lE/2,pE/2,0};
Line(22) = {13,15}; Line(23) = {15,16}; Line(24) = {16,14}; 
Line Loop(9) = {22,23,24,-20}; Plane Surface(9) = {9};

Transfinite Line{1,3,10,17,22,24} = 7;
Transfinite Line{12,14,16,18} = 9;
Transfinite Line{2,4,6,13,20,23} = 11;
Transfinite Line{5,7,9,11,19,21} = 4;
Transfinite Line{8,15} = 9;

Transfinite Surface{1,2,4,5,6,7,8,9};
Recombine Surface{1,2,4,5,6,7,8,9};

s2ext[] = {1,2,3,4,5,6,7,8,9};
out[] = Extrude{0,0,g} { Surface{s2ext[]}; Layers{3}; Recombine; };
s2ext[] = {out[0],out[2],out[4],out[6],out[8],out[10],out[12],out[14],out[16]};
out[] = Extrude{0,0,hb-g-ei} { Surface{s2ext[]}; Layers{8}; Recombine; };
s2ext[] = {out[0],out[2],out[8],out[14],out[16]};
out[] = Extrude{0,0,ei} { Surface{s2ext[]}; Layers{3}; Recombine; };
s2ext[] = {out[0],out[2],out[4],out[6],out[8]};
out[] = Extrude{0,0,hE-hb} { Surface{s2ext[]}; Layers{8}; Recombine; };

vg[] = {1}; vboba[] = {5,14}; vbobb[] = {7,16}; vbobc[] = {6,15};
vcore[] = {9,10,18,19,23,24,25,26,27,28};
vair[] = {2,3,4,8,11,12,13,17,20,21,22};

p = newp;
Point(p) = {Ri,0,0,lcdom}; Point(p+1) = {0,Ri,0,lcdom};
Point(p+2) = {0,0,Ri,lcdom};
l = newl; Line(l) = {15,p}; Circle(l+1) = {p,1,p+1}; Line(l+2) = {12,p+1};
ll = newll; Line Loop(ll) = {l,l+1,-(l+2),-17,-15,-21,-24,-23};
sxOy = news; Plane Surface(sxOy) = {ll}; 
Line(l+3) = {179,p+2}; Circle(l+4) = {p,1,p+2}; Circle(l+5) = {p+1,1,p+2};
Transfinite Line{l,l+2,l+3} = 8 Using Progression 1.2;

Point(p+3) = {Re,0,0,lcdom};
Point(p+4) = {0,Re,0,lcdom};
Point(p+5) = {0,0,Re,lcdom};
Line(l+6) = {p,p+3};
Line(l+7) = {p+1,p+4};
Line(l+8) = {p+2,p+5};
Circle(l+9) = {p+3,1,p+4};
Circle(l+10) = {p+3,1,p+5};
Circle(l+11) = {p+4,1,p+5};

Line Loop(ll+1) = {634, -635, -631, 203, 396, 506, 
  616, -610, -588, -566, -544, -522};
sxOz = news; Plane Surface(sxOz) = {ll+1}; 

Line Loop(ll+2) = {634, -636, -633, 167, 360, 349, 282, 426, 536, 525};
syOz = news; Plane Surface(syOz) = {ll+2}; 

Line Loop(ll+3) = {l+1,l+5,-(l+4)};
bord = news; Ruled Surface(bord) = {ll+3}; 
        
sbxOz[] = {529, 551, 573, 617, 595, 419, 441, 463, 485, 507,
  397, 375, 309, 226, 248, 33, 116, 55, 182, 204};
sbyOz[] = {365, 295, 238, 541, 431, 45, 102, 172};
sbxOy[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};
bordind[] = {630, 608, 586, 564, 542, 537, 559, 581, 603, 625, 515,
  493, 471, 449, 427, 278, 300, 366, 344, 361, 335, 383, 405, 168, 
  142, 190, 212, 208, 401, 511, 621};
sl = newsl;  Surface Loop(sl) = {bord,sxOy,syOz,sxOz,bordind[]};
vd = newv; Volume(vd) = {sl}; vair[] += vd;

Line Loop(ll+4) = {637,640,-638,-632}; s = news; Plane Surface(s) = {ll+4}; 
Line Loop(ll+5) = {637,641,-639,-635}; Plane Surface(s+1) = {ll+5}; 
Line Loop(ll+6) = {638,642,-639,-636}; Plane Surface(s+2) = {ll+6}; 
Line Loop(ll+7) = {l+9,l+11,-(l+10)}; Ruled Surface(s+3) = {ll+7}; 
sl = newsl; Surface Loop(sl) = {s,s+1,s+2,s+3,bord};
vbi = newv; Volume(vbi) = {sl};


Physical Volume(FERRITE) = {vcore[]};
Physical Volume(BOBINEA) = {vboba[]};
Physical Volume(BOBINEB) = {vbobb[]};
Physical Volume(BOBINEC) = {vbobc[]};
Physical Volume(AIR) = {vair[]};
Physical Volume(AIRGAP) = {vg};
Physical Volume(BOITEINF) = {vbi};

Physical Surface(BORDS) =  {529, 643, 551, 573, 617, 595, 
  507, 485, 463, 441, 419, 226, 248, 309, 397, 375, 
  204, 33, 55, 116, 182, 649, 650, 644, 541, 431, 238, 
  295, 365, 172, 102, 45, s+3};


Color DarkGrey {Volume{vcore[]};} 
Color Red {Volume{vboba[],vbobb[],vbobc[]};}
Color White {Volume{vg,vair[],vbi};}